from __future__ import print_function
import sys
import socket
import errno
import time
import threading
import thread
from collections import deque, OrderedDict

HOST = "192.168.1.215"
PORT = 55555

stopflag = threading.Event()
_tcpsocket = None


def incoming(connection, outstream):
    assert isinstance(connection, socket.socket)
    connection.settimeout(0.5)

    while not stopflag.is_set():
        data = None
        try:
            data = connection.recv(1024 * 4)
        except socket.timeout:
            time.sleep(.2)
            continue
        except socket.error as e:
            print(e)
            stopflag.set()

        else:
            if data:
                print("\nIN >>> ", data, file=outstream)

    try:
        connection.close()
    except socket.error as e:
        print(e)
        pass
    print("IN >>> STOPPED.")

s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
try:
    s.connect((HOST, PORT))
except socket.error as e:
    raise IOError("Can't connect to server %s an port %s" % (HOST, PORT))

thread.start_new_thread(incoming, (s, sys.stdout))

while True:
    try:
        print("\n(Ctl-D or Ctl-Z+Return to stop)")
        cmd = raw_input("Cmd to send: ")
    except EOFError:
        break
    else:
        s.sendall(cmd)

stopflag.set()
s.shutdown(socket.SHUT_RDWR)
