try:
    import poser
except ImportError:
    poser = SCENE = None
    raise RuntimeWarning("Script should run in Poser-Python.")
else:
    SCENE = poser.Scene()


def object_from_path(path):
    def extract_data(n):
        i_r = n.rfind("]")
        if i_r == -1:
            return n, None
        i_l = n.rfind("[")
        if i_l == -1:
            return n, None
        return n[:i_l], n[i_l + 1:i_r]

    def convert_data(d):
        if isinstance(d, basestring):
            if "," in d:
                d = d.split(",")
                for i, dd in enumerate(d):
                    d[i] = convert_data(dd.strip())
            else:
                try:
                    d = float(d)
                except:
                    pass

        if hasattr(d, "InternalName"):
            # prevent deeper loop
            # in case we got a poser object back.
            d = d.InternalName()
        return d

    if isinstance(path, basestring):
        path = [s.strip() for s in path.split("/")]

    base = SCENE
    if not path[0]:
        path.pop(0)
    if path[0].lower() == "scene":
        path.pop(0)
    if path[0] == "poser":
        path.pop(0)
        base = poser

    try:
        for p in path:
            cmd, data = extract_data(p)
            if data is None:
                base = getattr(base, cmd)()
            else:
                data = convert_data(data)
                if hasattr(data, "__iter__"):
                    base = getattr(base, cmd)(*data)
                else:
                    base = getattr(base, cmd)(data)
    except Exception as err:
        return "ERR: " + str(err)

    return convert_data(base)


